package chess.client;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**Start Box for Client Application
 * @author Garon
 *
 */
public class GuiClientStartBox extends JFrame {
	

	private static final long serialVersionUID = -633401598134672467L;
	
	public JPanel ipPanel;
	public JPanel portPanel;
	
	public JTextField ipBox;
	public JComboBox portBox;
	
	public String ipAddress = null;			//IP addres server is on
	public int	portNumber = 0;				//Port number
	
	public boolean isSet = false;
	
	/**Constructor for GuiClientStartBox
	 * @throws HeadlessException
	 */
	public GuiClientStartBox() throws HeadlessException {
		super();
		createUI();
		repaint();
	}
	/**Creates the UI for the start screen
	 * 
	 */
	protected void createUI() {

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
				System.exit(0);
			}
		});
		
		//Create and set up the content pane.
        JComponent newContentPane = new JPanel();
        newContentPane.setLayout(new BoxLayout(newContentPane, BoxLayout.Y_AXIS));
        newContentPane.setOpaque(true); //content panes must be opaque
        this.setContentPane(newContentPane);
		
        //Pane for ip address
        ipPanel = new JPanel(new GridLayout(1, 0));
		ipPanel.setBorder(BorderFactory.createTitledBorder("Server IP Address"));
		newContentPane.add(ipPanel,BorderLayout.CENTER);
		
		//IP address text pane
		ipBox = new JTextField();
		ipPanel.add(ipBox);
		
		//Pane for port number
		portPanel = new JPanel(new GridLayout(1, 0));
		portPanel.setBorder(BorderFactory.createTitledBorder("Port"));
		newContentPane.add(portPanel,BorderLayout.CENTER);	
		
		//Port number combo box
		String[] portStrings = {"Black Player" , "White Player"};		
		portBox = new JComboBox(portStrings);
		portBox.setSelectedIndex(0);
		portPanel.add(portBox);
		
		JButton okButton = new JButton("Ok");			
		
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ipAddress = ipBox.getText();
				if(portBox.getSelectedItem().equals("Black Player")){
					portNumber = 4445;
				}
				else if(portBox.getSelectedItem().equals("White Player")){
					portNumber = 4444;
				}
				
				if(ipAddress != null && portNumber != 0){
					isSet = true;				
					dispose();			    
				}
		    }			
		});		
		newContentPane.add(okButton, BorderLayout.CENTER);

        //Display the window.
        this.pack();
		center();
	}
	
	/**Centers the Gui on the screen
	 * 
	 */
	public void center() {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getSize();
		int x = (screenSize.width - frameSize.width) / 2;
		int y = (screenSize.height - frameSize.height) / 2;
		setLocation(x, y);
	}


}
