package chess.graphics;

import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

/**Class for Panel of Player selection types
 * @author Garon
 *
 */
public class PlayerSettingPanel extends JPanel {

	private static final long serialVersionUID = 1833307360535355279L;
	
	public PlayerType player = PlayerType.GUI;	
	
	public JComboBox aiDifficulty;
	public JComboBox aiStyle;

	/**Constructor for PlayerSettingPanel
	 * @param arg0		Alignment of Choices
	 */
	public PlayerSettingPanel(LayoutManager arg0) {
		super(arg0);

		JRadioButton guiButton = new JRadioButton("Human",true);
		JRadioButton netButton = new JRadioButton("Network", true);
		JRadioButton aiButton = new JRadioButton("AI");
		
		ButtonGroup group = new ButtonGroup();
		group.add(guiButton);
		group.add(netButton);
		group.add(aiButton);
		
		String[] diffStrings = {"Easy", "Medium", "Hard"};
		String[] styleStrings = {"Neutral", "Defensive", "Aggressive"};
		
		aiDifficulty = new JComboBox(diffStrings);
		aiDifficulty.setSelectedIndex(0);
		aiStyle = new JComboBox(styleStrings);
		aiStyle.setSelectedIndex(0);			
		aiDifficulty.setVisible(false);
		aiStyle.setVisible(false);		
		
		guiButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				player = PlayerType.GUI;
				aiDifficulty.setVisible(false);
				aiStyle.setVisible(false);
		    }			
		});
		netButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				player = PlayerType.NET;
				aiDifficulty.setVisible(false);
				aiStyle.setVisible(false);
		    }			
		});
		aiButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				player = PlayerType.AI;
				aiDifficulty.setVisible(true);
				aiStyle.setVisible(true);
		    }			
		});
		
		this.add(guiButton);
		this.add(netButton);
		this.add(aiButton);
		this.add(aiDifficulty);
		this.add(aiStyle);	
	}
	

	/**Get's the player
	 * @return Returns the player.
	 */
	public PlayerType getPlayer() {
		return player;
	}

	/**Set's the Player
	 * @param player The player to set.
	 */
	public void setPlayer(PlayerType player) {
		this.player = player;
	}
}
